import { useCssVars as K, ref as p, computed as d, watch as w, onMounted as Y, openBlock as c, createElementBlock as v, createElementVNode as i, normalizeStyle as x, createVNode as ee, renderSlot as te, createCommentVNode as k, unref as le, Fragment as P, renderList as z, withDirectives as E, vModelText as A, toDisplayString as R, pushScopeId as ae, popScopeId as ie } from "vue";
import ne from "./BaseIcon-DY4dOkkj.js";
import { t as oe, u as ue } from "./useResponsive-NZB-WLRF.js";
import { c as re, Q as V, P as B, X as se } from "./index-B6bGaBzE.js";
import { _ as de } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const O = (l) => (ae("data-v-bb159e36"), l = l(), ie(), l), me = {
  "data-html2canvas-ignore": "",
  style: { padding: "0 24px" }
}, ce = {
  class: "vue-data-ui-slicer-labels",
  style: { position: "relative", "z-index": "1", "pointer-events": "none" }
}, ve = {
  key: 0,
  style: { width: "100%", position: "relative" }
}, he = {
  key: 0,
  class: "minimap",
  style: { width: "100%" }
}, pe = ["xmlns", "viewBox"], fe = ["id"], ye = ["stop-color"], be = /* @__PURE__ */ O(() => /* @__PURE__ */ i("stop", {
  offset: "100%",
  "stop-color": "transparent"
}, null, -1)), ge = ["d", "stroke"], xe = ["x", "width", "height", "fill", "rx"], Se = ["d", "fill"], ke = ["x", "width", "height", "fill"], Ce = ["d", "stroke"], Ne = ["cx", "cy", "stroke", "fill"], we = ["cx", "cy", "stroke", "fill"], $e = ["x1", "x2", "y2", "stroke"], Ie = ["x", "height", "width", "onMouseenter"], Le = /* @__PURE__ */ O(() => /* @__PURE__ */ i("div", { class: "slider-track" }, null, -1)), Me = ["min", "max"], Fe = ["min", "max"], Pe = {
  __name: "Slicer",
  props: {
    background: {
      type: String,
      default: "#FFFFFF"
    },
    borderColor: {
      type: String,
      default: "#FFFFFF"
    },
    fontSize: {
      type: Number,
      default: 14
    },
    labelLeft: {
      type: String,
      default: ""
    },
    labelRight: {
      type: String,
      default: ""
    },
    textColor: {
      type: String,
      default: "#1A1A1A"
    },
    inputColor: {
      type: String,
      default: "#1A1A1A"
    },
    max: {
      type: Number,
      default: 0
    },
    min: {
      type: Number,
      default: 0
    },
    selectColor: {
      type: String,
      default: "#4A4A4A"
    },
    useResetSlot: {
      type: Boolean,
      default: !1
    },
    valueStart: {
      type: [Number, String],
      default: 0
    },
    valueEnd: {
      type: [Number, String],
      default: 0
    },
    minimap: {
      type: Array,
      default: []
    },
    smoothMinimap: {
      type: Boolean,
      default: !1
    },
    minimapSelectedColor: {
      type: String,
      default: "#1f77b4"
    },
    minimapSelectionRadius: {
      type: Number,
      default: 12
    },
    minimapLineColor: {
      type: String,
      default: "#2D353C"
    },
    minimapSelectedColorOpacity: {
      type: Number,
      default: 0.2
    },
    minimapSelectedIndex: {
      type: Number,
      default: null
    },
    minimapIndicatorColor: {
      type: String,
      default: "#2D353C"
    }
  },
  emits: ["update:start", "update:end", "reset", "trapMouse"],
  setup(l, { emit: y }) {
    const e = l;
    K((t) => ({
      "614b450c": T.value,
      "674fe5ee": S.value,
      ba246e42: W.value,
      "4785271e": l.selectColor,
      "1b74d2ac": U.value
    }));
    const u = p(e.min), r = p(e.max), b = d(() => !!e.minimap.length), $ = p(re()), D = d(() => {
      const t = e.max - e.min, a = (u.value - e.min) / t * 100, o = (r.value - e.min) / t * 100;
      return {
        left: `${a}%`,
        width: `${o - a}%`,
        background: e.selectColor
      };
    }), T = d(() => e.inputColor), U = d(() => e.background), W = d(() => `${e.selectColor}33`), S = d(() => e.borderColor), I = d(() => {
      let t = [];
      for (let a = 0; a < e.minimap.length; a += 1)
        t.push(a);
      return t;
    });
    function L() {
      y("reset");
    }
    function X() {
      Number(u.value) > Number(r.value) - 1 && (u.value = Number(r.value) - 1), y("update:start", Number(u.value));
    }
    function j() {
      Number(r.value) < Number(u.value) + 1 && (r.value = Number(u.value) + 1), y("update:end", Number(r.value));
    }
    w(
      () => e.min,
      (t) => {
        Number(u.value) < Number(t) && (u.value = Number(t)), Number(r.value) < Number(t) && (r.value = Number(t));
      }
    ), w(
      () => e.max,
      (t) => {
        Number(u.value) > Number(t) && (u.value = Number(t)), Number(r.value) > Number(t) && (r.value = Number(t));
      }
    );
    const C = p(null), n = p({
      width: 1,
      height: 1
    }), M = p(null);
    Y(() => {
      if (b.value) {
        const t = oe(() => {
          const { width: a, height: o } = ue({
            chart: C.value
          });
          n.value.width = a, n.value.height = o - 47;
        });
        M.value = new ResizeObserver(t), M.value.observe(C.value);
      }
    });
    const s = d(() => e.minimap.length ? n.value.width / e.minimap.length : 0), h = d(() => {
      if (!e.minimap.length) return [];
      const t = Math.max(...e.minimap), a = Math.min(...e.minimap) - 10, o = t - (a > 0 ? 0 : a), m = e.minimap.map((_, H) => {
        const J = _ - a;
        return {
          x: n.value.width / e.minimap.length * H + s.value / 2,
          y: n.value.height - J / o * (n.value.height * 0.9)
        };
      }), N = e.smoothMinimap ? V(m) : B(m), F = [...m].slice(e.valueStart, e.valueEnd), Z = e.smoothMinimap ? V(F) : B(F);
      return {
        fullSet: N,
        selectionSet: Z,
        firstPlot: m[e.valueStart],
        lastPlot: m[e.valueEnd - 1]
      };
    }), f = d(() => ({
      x: s.value * u.value + s.value / 2,
      width: n.value.width * ((r.value - u.value) / e.max) - s.value
    })), q = d(() => ({
      left: 0,
      color: e.textColor,
      fontSize: `${e.fontSize}px`,
      top: b.value ? "28px" : "-28px",
      pointerEvents: "none"
    })), G = d(() => ({
      right: 0,
      color: e.textColor,
      fontSize: `${e.fontSize}px`,
      top: b.value ? "28px" : "-28px",
      direction: "rtl",
      pointerEvents: "none"
    })), g = p(e.minimapSelectedIndex);
    w(() => e.minimapSelectedIndex, (t) => {
      g.value = t + e.valueStart;
    }, { immediate: !0 });
    function Q(t) {
      g.value = t, t >= e.valueStart && t < e.valueEnd && y("trapMouse", t - e.valueStart);
    }
    return (t, a) => (c(), v("div", me, [
      i("div", ce, [
        l.valueStart > 0 || l.valueEnd < l.max ? (c(), v("div", ve, [
          l.useResetSlot ? te(t.$slots, "reset-action", {
            key: 1,
            reset: L
          }, void 0, !0) : (c(), v("button", {
            key: 0,
            "data-cy-reset": "",
            tabindex: "0",
            role: "button",
            class: "vue-data-ui-refresh-button",
            style: x({
              top: b.value ? "36px" : "-16px",
              pointerEvents: "all !important"
            }),
            onClick: L
          }, [
            ee(ne, {
              name: "refresh",
              stroke: l.textColor
            }, null, 8, ["stroke"])
          ], 4))
        ])) : k("", !0)
      ]),
      i("div", {
        class: "double-range-slider",
        ref_key: "minimapWrapper",
        ref: C,
        style: { "z-index": "0" }
      }, [
        b.value ? (c(), v("div", he, [
          (c(), v("svg", {
            xmlns: le(se),
            viewBox: `0 0 ${n.value.width < 0 ? 0 : n.value.width} ${n.value.height < 0 ? 0 : n.value.height}`
          }, [
            i("defs", null, [
              i("linearGradient", {
                id: $.value,
                x1: "0%",
                y1: "0%",
                x2: "0%",
                y2: "100%"
              }, [
                i("stop", {
                  offset: "0%",
                  "stop-color": `${l.minimapLineColor}50`
                }, null, 8, ye),
                be
              ], 8, fe)
            ]),
            i("path", {
              d: `M${h.value.fullSet}`,
              stroke: `${l.minimapLineColor}`,
              fill: "none",
              "stroke-width": "1",
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              style: { opacity: "1" }
            }, null, 8, ge),
            i("rect", {
              x: f.value.x,
              width: f.value.width < 0 ? 0 : f.value.width,
              height: n.value.height,
              y: 0,
              fill: S.value,
              rx: l.minimapSelectionRadius,
              stroke: "none"
            }, null, 8, xe),
            i("path", {
              d: `M${s.value / 2},${n.value.height} ${h.value.fullSet} L${n.value.width - s.value / 2},${n.value.height}Z`,
              fill: `url(#${$.value})`,
              stroke: "none",
              style: { opacity: "1" }
            }, null, 8, Se),
            i("rect", {
              x: f.value.x,
              width: f.value.width < 0 ? 0 : f.value.width,
              height: n.value.height,
              y: 0,
              fill: l.minimapSelectedColor,
              style: x({
                opacity: l.minimapSelectedColorOpacity
              })
            }, null, 12, ke),
            i("path", {
              d: `M ${h.value.selectionSet}`,
              stroke: `${l.minimapLineColor}`,
              fill: "transparent",
              "stroke-width": "2",
              "stroke-linecap": "round",
              "stroke-linejoin": "round"
            }, null, 8, Ce),
            i("circle", {
              cx: h.value.firstPlot.x,
              cy: h.value.firstPlot.y,
              "stroke-width": "0.5",
              stroke: S.value,
              r: "3",
              fill: l.minimapLineColor
            }, null, 8, Ne),
            i("circle", {
              cx: h.value.lastPlot.x,
              cy: h.value.lastPlot.y,
              "stroke-width": "0.5",
              stroke: S.value,
              r: "3",
              fill: l.minimapLineColor
            }, null, 8, we),
            g.value !== null ? (c(!0), v(P, { key: 0 }, z(I.value, (o, m) => (c(), v("g", null, [
              g.value === o && o >= l.valueStart && o < l.valueEnd ? (c(), v("line", {
                key: 0,
                x1: s.value * m + s.value / 2,
                x2: s.value * m + s.value / 2,
                y1: 0,
                y2: n.value.height,
                stroke: l.minimapIndicatorColor,
                "stroke-linecap": "round",
                "stroke-dasharray": "2",
                "stroke-width": "1"
              }, null, 8, $e)) : k("", !0)
            ]))), 256)) : k("", !0),
            (c(!0), v(P, null, z(I.value, (o, m) => (c(), v("rect", {
              x: s.value * m,
              y: 0,
              height: n.value.height,
              width: s.value,
              fill: "transparent",
              style: { "pointer-events": "all !important" },
              onMouseenter: (N) => Q(o),
              onMouseleave: a[0] || (a[0] = (N) => {
                g.value = null, y("trapMouse", null);
              })
            }, null, 40, Ie))), 256))
          ], 8, pe))
        ])) : k("", !0),
        Le,
        i("div", {
          class: "range-highlight",
          style: x(D.value)
        }, null, 4),
        E(i("input", {
          type: "range",
          class: "range-left",
          min: l.min,
          max: l.max,
          "onUpdate:modelValue": a[1] || (a[1] = (o) => u.value = o),
          onInput: X
        }, null, 40, Me), [
          [A, u.value]
        ]),
        i("div", {
          class: "thumb-label thumb-label-left",
          style: x(q.value)
        }, R(l.labelLeft), 5),
        E(i("input", {
          type: "range",
          class: "range-right",
          min: l.min,
          max: l.max,
          "onUpdate:modelValue": a[2] || (a[2] = (o) => r.value = o),
          onInput: j
        }, null, 40, Fe), [
          [A, r.value]
        ]),
        i("div", {
          class: "thumb-label thumb-label-right",
          style: x(G.value)
        }, R(l.labelRight), 5)
      ], 512)
    ]));
  }
}, Be = /* @__PURE__ */ de(Pe, [["__scopeId", "data-v-bb159e36"]]);
export {
  Be as S
};
